'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _antd = require('antd');

var _FormElements = require('./FormElements');

var _FormElements2 = _interopRequireDefault(_FormElements);

var _objectPath = require('./objectPath');

var _objectPath2 = _interopRequireDefault(_objectPath);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var T = _react2.default.PropTypes;

/**
 * [Custom]
 */
var DynamicForm = _react2.default.createClass({
	displayName: 'DynamicForm',
	render: function render() {
		var path = this.props.schema.name || 'root';
		return _react2.default.createElement(
			_antd.Form,
			{ horizontal: true },
			_react2.default.createElement(_FormElements2.default.Object, _extends({}, this.props.schema, {
				path: path,
				key: path,
				initialValue: this.props.initialValue,
				form: this.props.form
			})),
			this.renderSubmitButton()
		);
	},
	renderSubmitButton: function renderSubmitButton() {
		return _react2.default.createElement(
			_antd.Form.Item,
			{ wrapperCol: { span: 12, offset: 7 } },
			_react2.default.createElement(
				_antd.Button,
				{
					type: 'primary',
					onClick: this.handleSubmit },
				'确定'
			),
			'   ',
			_react2.default.createElement(
				_antd.Button,
				{
					type: 'ghost',
					onClick: this.handleReset },
				'重置'
			)
		);
	},
	handleReset: function handleReset(e) {
		e.preventDefault();
		this.props.form.resetFields();
	},
	handleSubmit: function handleSubmit(e) {
		var _this = this;

		e.preventDefault();
		this.props.form.validateFields(function (errors, values) {
			if (!!errors) {
				console.log('Errors in form!!!');
				return;
			}
			_this.props.onSubmit(_this.revealValueObject(values[_this.props.schema.name]));
		});
	},
	revealValueObject: function revealValueObject(obj) {
		var ret = {};
		var keys = Object.keys(obj);

		keys.forEach(function (key) {
			if (key.indexOf('__internal__') === -1) {
				_objectPath2.default.set(ret, key, obj[key]);
			}
		});

		return ret;
	}
	// userExists(rule, value, callback) {
	//     if (!value) {
	//       callback();
	//     } else {
	//       setTimeout(() => {
	//         if (value === 'JasonWood') {
	//           callback([new Error('抱歉，该用户名已被占用。')]);
	//         } else {
	//           callback();
	//         }
	//       }, 800);
	//     }
	// }

});

exports.default = DynamicForm;