'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; // {
// 	name: 'keyArr',
// 	type: 'Array',
// 	itemSchema: {
// 		type: 'object',
// 		elements: [{
// 			name: 'inputText',
// 			type: 'TextInput'
// 		}, {
// 			name: 'inputText',
// 			type: 'TextArea'
// 		}]
// 	}
// }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _antd = require('antd');

var _index = require('./index');

var _index2 = _interopRequireDefault(_index);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var T = _react2.default.PropTypes;

var ArrayType = _react2.default.createClass({
	propTypes: {
		path: T.string.isRequired
	},
	displayName: 'DynamicForm.Array',
	getDefaultProps: function getDefaultProps() {
		return {
			initialValue: []
		};
	},
	getInitialState: function getInitialState() {
		return this.getStateFromProps(this.props);
	},
	getStateFromProps: function getStateFromProps(props) {
		var itemSchema = props.itemSchema;


		var itemSchemaString = JSON.stringify(itemSchema);
		var initialValue = this.props.initialValue;
		var items = [];

		for (var i = 0, l = initialValue.length; i <= l; i++) {
			items.push(JSON.parse(itemSchemaString));
		}

		return {
			items: items
		};
	},
	componentWillReceiveProps: function componentWillReceiveProps(nextProps) {
		this.setState(this.getStateFromProps(nextProps));
	},
	render: function render() {
		var _props$form = this.props.form;
		var getFieldProps = _props$form.getFieldProps;
		var getFieldValue = _props$form.getFieldValue;

		var key = this.getKey();

		var arrayField = getFieldProps(key, {
			initialValue: this.getStateFromProps(this.props).items
		});

		// title
		var $title = null;
		if (this.props.label) {
			$title = _react2.default.createElement(
				'h3',
				null,
				this.props.label
			);
		}

		return _react2.default.createElement(
			'div',
			{ className: 'df-array' },
			$title,
			this.renderElements(getFieldValue(key))
		);
	},
	getKey: function getKey() {
		return '__internal__.' + this.props.path + '__arr';
	},
	renderElements: function renderElements(items) {
		var _this = this;

		var props = this.props;
		var parentPath = props.path;
		var initialValue = this.props.initialValue;

		return items.map(function (it, index) {
			var Element = _index2.default[it.type];
			if (Element) {
				var path = parentPath + '.' + index;
				return _react2.default.createElement(
					ArrayItem,
					{
						addItem: _this.onAddItem,
						removeItem: _this.onRemoveItem,
						item: it,
						key: path
					},
					_react2.default.createElement(Element, _extends({}, it, {
						path: path,
						name: index + '',
						initialValue: initialValue[index],
						key: path,
						form: props.form
					}))
				);
			}
			return '';
		});
	},
	onAddItem: function onAddItem() {
		var _props$form2 = this.props.form;
		var getFieldValue = _props$form2.getFieldValue;
		var setFieldsValue = _props$form2.setFieldsValue;

		var key = this.getKey();

		var items = getFieldValue(key);
		items.push(JSON.parse(JSON.stringify(this.props.itemSchema)));

		var obj = {};
		obj[key] = items;
		setFieldsValue(obj);
	},
	onRemoveItem: function onRemoveItem(item) {
		var _props$form3 = this.props.form;
		var getFieldValue = _props$form3.getFieldValue;
		var setFieldsValue = _props$form3.setFieldsValue;

		var key = this.getKey();

		var items = getFieldValue(key);
		items = items.filter(function (it) {
			return it !== item;
		});

		var obj = {};
		obj[key] = items;
		setFieldsValue(obj);
	}
});

var ArrayItem = _react2.default.createClass({
	displayName: 'ArrayItem',
	render: function render() {
		return _react2.default.createElement(
			'div',
			{ className: 'df-array-item ant-row' },
			this.props.children,
			_react2.default.createElement(
				'span',
				{ className: 'df-array-item-ctrl' },
				_react2.default.createElement(
					_antd.Button,
					{
						type: 'ghost',
						shape: 'circle',
						onClick: this.onClickAdd },
					_react2.default.createElement(_antd.Icon, { type: 'plus' })
				),
				_react2.default.createElement(
					_antd.Button,
					{
						type: 'ghost',
						shape: 'circle',
						onClick: this.onClickMinus },
					_react2.default.createElement(_antd.Icon, { type: 'minus' })
				)
			)
		);
	},
	onClickAdd: function onClickAdd() {
		this.props.addItem();
	},
	onClickMinus: function onClickMinus() {
		this.props.removeItem(this.props.item);
	}
});

exports.default = ArrayType;