'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _antd = require('antd');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var FormItem = _antd.Form.Item;

var T = _react2.default.PropTypes;

var Checkboxes = _react2.default.createClass({
	displayName: 'Checkboxes',

	propTypes: {
		label: T.string,
		labelColSpan: T.number,
		wrapperColSpan: T.number,
		help: T.string,
		tip: T.string,
		value: T.string,
		form: T.object.isRequired,
		path: T.string.isRequired,
		initialValue: T.object
	},
	getDefaultProps: function getDefaultProps() {
		return {
			label: '多选',
			labelColSpan: 6,
			wrapperColSpan: 14,
			initialValue: {}
		};
	},
	render: function render() {

		var props = this.props;

		var itemProps = {
			label: props.label,
			labelCol: { span: props.labelColSpan },
			wrapperCol: { span: props.wrapperColSpan }
		};

		if (props.help) {
			itemProps.help = props.help;
		}

		if (props.tip) {
			itemProps.label = _react2.default.createElement(
				'span',
				null,
				props.label,
				_react2.default.createElement(
					_antd.Tooltip,
					{ title: props.tip },
					_react2.default.createElement(_antd.Icon, { type: 'question-circle-o' })
				)
			);
		}

		return _react2.default.createElement(
			FormItem,
			itemProps,
			this.renderCheckboxes()
		);
	},
	renderCheckboxes: function renderCheckboxes() {
		var props = this.props;
		var getFieldProps = this.props.form.getFieldProps;


		return props.checkboxes.map(function (ck) {

			var fieldProps = getFieldProps(props.path + '.' + ck.name, {
				valuePropName: 'checked',
				rules: ck.rules,
				initialValue: props.initialValue[ck.name]
			});

			return _react2.default.createElement(
				_antd.Checkbox,
				_extends({}, fieldProps, {
					className: 'ant-checkbox-vertical',
					key: ck.id }),
				ck.label
			);
		});
	}
});

exports.default = Checkboxes;