'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _antd = require('antd');

var _index = require('./index');

var _index2 = _interopRequireDefault(_index);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ObjectType(props) {

	var $title = null;

	if (props.label) {
		$title = _react2.default.createElement(
			'h3',
			null,
			props.label
		);
	}

	return _react2.default.createElement(
		'div',
		{ className: 'df-object' },
		$title,
		renderElements()
	);

	function renderElements() {
		var elements = props.elements;
		var parentPath = props.path;
		var initialValue = props.initialValue || {};
		return elements.map(function (option) {
			var Element = _index2.default[option.type];

			var path = parentPath + '.' + option.name;
			var elementInitialValue = initialValue[option.name];

			// checkbox is special
			if (option.type === 'Checkboxes') {
				path = parentPath;
				elementInitialValue = initialValue;
			}

			if (Element) {
				return _react2.default.createElement(Element, _extends({}, option, {
					path: path,
					initialValue: elementInitialValue,
					key: path,
					form: props.form
				}));
			}

			return null;
		});
	}
}

ObjectType.displayName = 'DynamicForm.Object';

exports.default = ObjectType;