'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _antd = require('antd');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var FormItem = _antd.Form.Item;

var RadioGroup = _antd.Radio.Group;
var T = _react2.default.PropTypes;

var Radios = _react2.default.createClass({
	displayName: 'Radios',

	propTypes: {
		label: T.string,
		labelColSpan: T.number,
		wrapperColSpan: T.number,
		help: T.string,
		tip: T.string,
		value: T.string,
		rules: T.array,
		radios: T.array,
		form: T.object.isRequired,
		path: T.string.isRequired
	},
	getDefaultProps: function getDefaultProps() {
		return {
			label: '单选',
			labelColSpan: 6,
			wrapperColSpan: 14
		};
	},
	render: function render() {

		var props = this.props;

		var itemProps = {
			label: props.label,
			labelCol: { span: props.labelColSpan },
			wrapperCol: { span: props.wrapperColSpan }
		};

		if (props.help) {
			itemProps.help = props.help;
		}

		if (props.tip) {
			itemProps.label = _react2.default.createElement(
				'span',
				null,
				props.label,
				_react2.default.createElement(
					_antd.Tooltip,
					{ title: props.tip },
					_react2.default.createElement(_antd.Icon, { type: 'question-circle-o' })
				)
			);
		}

		return _react2.default.createElement(
			FormItem,
			itemProps,
			this.renderRadios()
		);
	},
	renderRadios: function renderRadios() {
		var props = this.props;
		var getFieldProps = this.props.form.getFieldProps;


		var fieldProps = getFieldProps(props.path, {
			rules: props.rules,
			initialValue: props.initialValue
		});

		if (props.defaultValue) {
			fieldProps.defaultValue = props.defaultValue;
		}

		return _react2.default.createElement(
			RadioGroup,
			fieldProps,
			props.radios.map(function (r) {
				return _react2.default.createElement(
					_antd.Radio,
					{
						value: r.value,
						key: r.value + r.label + props.id },
					r.label
				);
			})
		);
	}
});

exports.default = Radios;