'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _antd = require('antd');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var FormItem = _antd.Form.Item;

var Option = _antd.Select.Option;
var T = _react2.default.PropTypes;

var MSelect = _react2.default.createClass({
	displayName: 'MSelect',

	propTypes: {
		label: T.string,
		labelColSpan: T.number,
		wrapperColSpan: T.number,
		help: T.string,
		tip: T.string,
		value: T.string,
		rules: T.array,
		form: T.object.isRequired,
		path: T.string.isRequired
	},
	getDefaultProps: function getDefaultProps() {
		return {
			label: '下拉选择',
			labelColSpan: 6,
			wrapperColSpan: 14,
			placeholder: '请选择'
		};
	},
	render: function render() {

		var props = this.props;

		var itemProps = {
			label: props.label,
			labelCol: { span: props.labelColSpan },
			wrapperCol: { span: props.wrapperColSpan }
		};

		if (props.help) {
			itemProps.help = props.help;
		}

		if (props.tip) {
			itemProps.label = _react2.default.createElement(
				'span',
				null,
				props.label,
				_react2.default.createElement(
					_antd.Tooltip,
					{ title: props.tip },
					_react2.default.createElement(_antd.Icon, { type: 'question-circle-o' })
				)
			);
		}

		return _react2.default.createElement(
			FormItem,
			itemProps,
			this.renderSelect()
		);
	},
	renderSelect: function renderSelect() {
		var props = this.props;
		var getFieldProps = this.props.form.getFieldProps;


		var fieldProps = getFieldProps(props.path, {
			rules: props.rules,
			initialValue: props.initialValue
		});

		// @TODO defaultValue does not work
		if (props.defaultValue) {
			fieldProps.defaultValue = props.defaultValue;
		}

		return _react2.default.createElement(
			_antd.Select,
			_extends({}, fieldProps, {
				placeholder: props.placeholder,
				style: { width: '100%' } }),
			props.options.map(function (r) {
				return _react2.default.createElement(
					Option,
					{
						value: r.value,
						key: r.value + r.label + props.id },
					r.label
				);
			})
		);
	}
});

exports.default = MSelect;