'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _antd = require('antd');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var FormItem = _antd.Form.Item;

var T = _react2.default.PropTypes;

var TextInput = _react2.default.createClass({
	displayName: 'TextInput',

	propTypes: {
		label: T.string,
		labelColSpan: T.number,
		wrapperColSpan: T.number,
		help: T.string,
		tip: T.string,
		value: T.string,
		required: T.bool,
		disabled: T.bool,
		readonly: T.bool,
		placeholder: T.string,
		form: T.object.isRequired,
		name: T.string.isRequired,
		rules: T.array,
		path: T.string.isRequired
	},
	getDefaultProps: function getDefaultProps() {
		return {
			label: '输入框',
			labelColSpan: 6,
			wrapperColSpan: 14,
			disabled: false,
			readonly: false,
			required: false,
			placeholder: "请输入..."
		};
	},
	render: function render() {

		var props = this.props;
		var getFieldProps = this.props.form.getFieldProps;

		var fieldProps = getFieldProps(props.path, {
			rules: props.rules,
			onChange: this.onChange
		});

		var itemProps = {
			label: props.label,
			labelCol: { span: props.labelColSpan },
			wrapperCol: { span: props.wrapperColSpan }
		};

		if (props.help) {
			itemProps.help = props.help;
		}

		if (props.tip) {
			itemProps.label = _react2.default.createElement(
				'span',
				null,
				props.label,
				_react2.default.createElement(
					_antd.Tooltip,
					{ title: props.tip },
					_react2.default.createElement(_antd.Icon, { type: 'question-circle-o' })
				)
			);
		}

		return _react2.default.createElement(
			FormItem,
			itemProps,
			_react2.default.createElement(_antd.Input, _extends({}, fieldProps, { placeholder: props.placeholder }))
		);
	},
	onChange: function onChange() {
		console.log('onChange');
	}
});

exports.default = TextInput;