'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _antd = require('antd');

var _FormElements = require('./FormElements');

var _FormElements2 = _interopRequireDefault(_FormElements);

var _DynamicForm = require('./DynamicForm');

var _DynamicForm2 = _interopRequireDefault(_DynamicForm);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var createForm = _antd.Form.create;
var T = _react2.default.PropTypes;
var F = function F() {};
var FormGenerator = _react2.default.createClass({
	displayName: 'FormGenerator',
	getInitialState: function getInitialState() {
		var options = {
			onFieldsChange: this.onFieldsChange
		};
		var CustomForm = createForm(options)(_DynamicForm2.default);
		return {
			CustomForm: CustomForm
		};
	},

	propTypes: {
		schema: T.shape({
			name: T.string.isRequired,
			id: T.string.isRequired,
			description: T.string,
			elements: T.array,
			onSubmit: T.func,
			onFieldsChange: T.func
		}),
		initialValue: T.object
	},
	getDefaultProps: function getDefaultProps() {
		return {
			schema: {
				elements: []
			},
			initialValues: {},
			onSubmit: F,
			onFieldsChange: F
		};
	},
	render: function render() {
		var CustomForm = this.state.CustomForm;
		return _react2.default.createElement(
			'div',
			{ className: 'dynamic-form' },
			_react2.default.createElement(CustomForm, _extends({}, this.props, {
				onSubmit: this.onSubmit
			}))
		);
	},

	/**
  * 当 Form.Item 子节点的值发生改变时触发，可以把对应的值转存到 Redux store
  * @param  {[type]} props  [description]
  * @param  {[type]} fields [description]
  * @return {[type]}        [description]
  */
	onFieldsChange: function onFieldsChange(props, fields) {
		this.props.onFieldsChange(props, fields);
	},

	/**
  * [onSubmit description]
  * @param  {[type]} values [description]
  * @return {[type]}        [description]
  */
	onSubmit: function onSubmit(values) {
		this.props.onSubmit(values);
	}
});

exports.default = FormGenerator;