import React from 'react';
import { Form, Button} from 'antd';
import FormElements from './FormElements';
import objectPath from './objectPath';

const T = React.PropTypes;

/**
 * [Custom]
 */
const DynamicForm = React.createClass({
	render() {
		const path = this.props.schema.name || 'root';
		return (
			<Form horizontal>
				<FormElements.Object 
					{...this.props.schema}
					path={path}
					key={path}
					initialValue={this.props.initialValue}
					form={this.props.form}
					/>
				{this.renderSubmitButton()}
			</Form>
		)
	},

	renderSubmitButton() {
		return (
			<Form.Item wrapperCol={{ span: 12, offset: 7 }}>
		        <Button 
		          	type="primary" 
		          	onClick={this.handleSubmit}>
		          	确定
		        </Button>
	          &nbsp;&nbsp;&nbsp;
	        	<Button 
	        		type="ghost" 
	        		onClick={this.handleReset}>
	        		重置
	        	</Button>
	        </Form.Item>
		)
	},

	handleReset(e) {
	    e.preventDefault();
	    this.props.form.resetFields();
	},
	handleSubmit(e) {
	    e.preventDefault();
	    this.props.form.validateFields((errors, values) => {
	      if (!!errors) {
	        console.log('Errors in form!!!');
	        return;
	      }
	      this.props.onSubmit(this.revealValueObject(values[this.props.schema.name]));
	    });
	},
	revealValueObject(obj) {
		let ret = {};
		const keys = Object.keys(obj);

		keys.forEach(key => {
			if (key.indexOf('__internal__') === -1) {
				objectPath.set(ret, key, obj[key]);
			}
		});

		return ret;
	}
	// userExists(rule, value, callback) {
	//     if (!value) {
	//       callback();
	//     } else {
	//       setTimeout(() => {
	//         if (value === 'JasonWood') {
	//           callback([new Error('抱歉，该用户名已被占用。')]);
	//         } else {
	//           callback();
	//         }
	//       }, 800);
	//     }
	// }
});

export default DynamicForm;