import React from 'react';
import { Form, Button} from 'antd';
import FormElements from './index';

function ObjectType(props) {

	let $title = null;

	if (props.label) {
		$title = <h3>{props.label}</h3>
	}

	return (
		<div className="df-object">
			{$title}
			{renderElements()}
		</div>
	)

	function renderElements() {
		const elements = props.elements;
		const parentPath = props.path;
		const initialValue = props.initialValue || {};
		return elements.map((option) => {
			const Element = FormElements[option.type];

			let path = `${parentPath}.${option.name}`;
			let elementInitialValue = initialValue[option.name];

			// checkbox is special
			if (option.type === 'Checkboxes') {
				path = parentPath;
				elementInitialValue = initialValue;
			}

			if (Element) {
				return <Element 
							{...option} 
							path={path}
							initialValue={elementInitialValue}
							key={path}
							form={props.form}
						/>
			}

			return null;
		})
	}
}

ObjectType.displayName = 'DynamicForm.Object'

export default ObjectType;