import React from 'react';
import { Form, Input, Select, Button, Checkbox, Radio, Tooltip, Icon } from 'antd';
const FormItem = Form.Item;

const Option = Select.Option;
const T = React.PropTypes;

const MSelect = React.createClass({
	propTypes: {
		label: T.string,
		labelColSpan: T.number,
		wrapperColSpan: T.number,
		help: T.string,
		tip: T.string,
		value: T.string,
		rules: T.array,
		form: T.object.isRequired,
		path: T.string.isRequired
	},
	getDefaultProps() {
		return {
			label: '下拉选择',
			labelColSpan: 6,
			wrapperColSpan: 14,
			placeholder: '请选择'
		}
	},
	render() {

		const props = this.props;
		
		let itemProps = {
		    label: props.label,
		    labelCol: { span: props.labelColSpan },
		    wrapperCol: { span: props.wrapperColSpan }
		}

		if (props.help) {
			itemProps.help = props.help;
		}

		if (props.tip) {
			itemProps.label = (
				<span>
					{props.label}
					<Tooltip title={props.tip}>
					 	<Icon type="question-circle-o" />
					</Tooltip>
				</span>
			)
		}

		return (
			<FormItem {...itemProps}>
				{this.renderSelect()}
		    </FormItem>
		)
	},

	renderSelect() {
		const props = this.props;
		const { getFieldProps} = this.props.form;

		const fieldProps = getFieldProps(props.path, {
			rules: props.rules,
			initialValue: props.initialValue
		});

		// @TODO defaultValue does not work
		if (props.defaultValue) {
			fieldProps.defaultValue = props.defaultValue;
		}

		return (
			<Select 
				{...fieldProps} 
				placeholder={props.placeholder}
				style={{ width: '100%' }}>
				{props.options.map(r => {
					return (
						<Option 
							value={r.value} 
							key={r.value + r.label + props.id}>
							{r.label}
						</Option>
					)
				})}
		    </Select>
		)
	}
});

export default MSelect;