import React from 'react';
import { Form, Button} from 'antd';
import FormElements from './FormElements';
import DynamicForm from './DynamicForm';

const createForm = Form.create;
const T = React.PropTypes;
const F = function() {};
const FormGenerator = React.createClass({
	getInitialState() {
		const options = {
			onFieldsChange: this.onFieldsChange
		}
		const CustomForm = createForm(options)(DynamicForm);
	    return {
	        CustomForm  
	    };
	},
	propTypes: {
		schema: T.shape({
			name: T.string.isRequired,
			id: T.string.isRequired,
			description: T.string,
			elements: T.array,
			onSubmit: T.func,
			onFieldsChange: T.func
		}),
		initialValue: T.object
	},
	getDefaultProps() {
	    return {
	        schema: {
	        	elements: []
	        },
	        initialValues: {},
	        onSubmit: F,
	        onFieldsChange: F
	    };
	},
	render() {
		const CustomForm = this.state.CustomForm;
		return (
			<div className="dynamic-form">
				<CustomForm
					{...this.props}
					onSubmit={this.onSubmit}
				/>
			</div>
		)
	},
	/**
	 * 当 Form.Item 子节点的值发生改变时触发，可以把对应的值转存到 Redux store
	 * @param  {[type]} props  [description]
	 * @param  {[type]} fields [description]
	 * @return {[type]}        [description]
	 */
	onFieldsChange(props, fields) {
		this.props.onFieldsChange(props, fields);
	},
	/**
	 * [onSubmit description]
	 * @param  {[type]} values [description]
	 * @return {[type]}        [description]
	 */
	onSubmit(values) {
		this.props.onSubmit(values);
	}
});

export default FormGenerator;