var webpack = require("webpack");
var glob = require('glob');

var vendor = [
  'react',
  'react-dom',
  'antd'
];

var externals = vendor.reduce(function (memo, it){
  memo[it] = {
    root: it,
    commonjs2: it,
    commonjs: it,
    amd: it,
  }
  return memo;
}, {});

var config = {
  watch: true,
  entry: {
    FormGenerator: __dirname + '/src/js/home/components/FormDesigner.js'
  },
  output: {
    path: __dirname + '/bin/lib/',
    filename: '[name].js',
    pathinfo: true,
    libraryTarget: 'umd',
    library: '[name]'
  },
  module: {
    loaders: [
      {
        test: /\.js$/,
        exclude: /node_modules/,
        loader: 'babel',
        query: { 
          presets: [ 'es2015', 'stage-0', 'react'] 
        }
      },
      {
        test: /\.jsx$/,
        exclude: /node_modules/,
        loader: 'babel',
        query: { 
          presets: [ 'es2015', 'stage-0', 'react' ] 
        }
      }
    ]
  },
  externals: externals,
  resolve: {
    extensions: ['', '.js', '.jsx'] 
  }
};

module.exports = config;